// Scroll.c - Tuesday 29th September '98
// Programmed by Colin Phillips (MEMIR)
// This program was created so that you can see what exactly is possible with
// my C compiler.
// E-mail: colin_phillips@yahoo.com
/////////////////////////////////////////////////////////////////////////////

// mfuncs.h (Header file!!) ----------------------------------------------
// would have these externs but thats once you've reg'ed!!!

extern u32     arg_w; 
extern u32     arg_x;
extern u32     arg_y;
extern u32     arg_c;
extern u32     arg_z;
extern u32     arg_1;
extern u32     arg_2;
extern u32     arg_3;
extern u32     arg_4;

extern u32     ret_1;
extern u32     ret_2;
extern u32     ret_3;
extern u32     ret_4;

extern u32     PCXIMGS;
extern u32     PCXIMGE;

u32 x;
u32 y;
u32 z;

u32 x1;
u32 y1;
u32 z1;

u32 x2;
u32 y2;
u32 z2;

u32 _MemirStdText.Color;
u32 _MemirStdText.Shiftx;
u32 _MemirStdText.Shifty;
u32 _MemirStdText.Back;

u32     Slice1.dir;
u32     Slice1.x;
u32     Slice1.color;

u32     Slice2.dir;
u32     Slice2.c; 

u32     Slice3.fc;

u32     Slice4.line[64];
u32     Slice4.line_no;
u32     Slice4.line_off;


void main(void)
{
VIDEO_MODE();
// ----------------------------------------------------------------------- //
PrepareBackground();
InitSlices();
begin:
MemirCopyVscr(1,0);

DoSlice1();     // Slice one is the message that says "Demo in Memir-C"
DoSlice2();         // Slice two is the note at the bot-right "colin_phillips@yahoo.com"
DoSlice3();	    // Displays the "Counter"
DoSlice4();	    // This is the Main Text.
MemirShowVscr();
goto begin;

safety:

goto safety;
}

// void MemirDispWord(u32 value,u32 x,u32 y)
// This is our First proper N64 Function, Whaddya Think?
 
void MemirDispWord(u32 value,u32 x,u32 y)
{
        ret_1 = value;
        4xalign();

        arg_x = x;
        arg_y = y;
        arg_c = 65535;
        arg_z = ret_4;

        ASM_NUM_FONT();
        arg_x = x+16;
        arg_y = y;
        arg_c = 65535;
        arg_z = ret_3;
        ASM_NUM_FONT();

        arg_x = x+32;
        arg_y = y;
        arg_c = 65535;
        arg_z = ret_2;
        ASM_NUM_FONT();

        arg_x = x+48;
        arg_y = y;
        arg_c = 65535;
        arg_z = ret_1;
        ASM_NUM_FONT();
}

void MemirDrawPcx(u32 pcx_start,u32 pcx_end,u32 x,u32 y)
{
        arg_x = x;
        arg_y = y;
        arg_z = pcx_start;
        arg_w = pcx_end;
        ASM_PCX_VIEW();
}

void MemirDrawSprite16(u32 spr_no,u32 x,u32 y)
{
        arg_x = x;
        arg_y = y;
        arg_z = spr_no;
        ASM_SPRITE16();
}

void MemirClearVscr(u32 vscr_no)
{
        arg_z = vscr_no;
        asm_clear_vscr();
}

void MemirShowVscr(void)
{
        asm_show_vscr();        // no params assumes you are talking about page #0
}

void MemirCopyVscr(u32 src,u32 dest)
{
        arg_z = src;    // Dest is irr. since we know that there is only two pages!
        asm_copy_vscr();
}

void MemirStdTextColor(u32 r,u32 g,u32 b)
{
        _MemirStdText.Color = r*2048;
        _MemirStdText.Color = _MemirStdText.Color + g*64;
        _MemirStdText.Color = _MemirStdText.Color + b*2;
}

void MemirStdTextShift(u32 sx,u32 sy)
{
        _MemirStdText.Shiftx = sx;
        _MemirStdText.Shifty = sy;
}

void MemirStdTextBack(u32 back)
{
        _MemirStdText.Back = back;
}

void MemirStdText(u32 ptr,u32 x,u32 y)
{
        arg_w = ptr;
        arg_x = x;
        arg_y = y;
        arg_c = _MemirStdText.Color;
        arg_1 = _MemirStdText.Shiftx;      // Spacing
        arg_2 = _MemirStdText.Shifty;
        arg_3 = _MemirStdText.Back;
        ASM_TEXT();
}

 //////////////////////////////////////////////////////////////////////////////

void PrepareBackground(void)
{
        x=0;    // Pastes sprite #1 onto the background!
        y=0;
        PBloop:
        MemirDrawSprite16(1,x*16,y*16);
        x=x+1;
        if(x>19)
                {
                x=0;
                y=y+1;
                }
        if(y<15)
                {
                goto PBloop;
                }
MemirDrawPcx(&PCXIMGS,&PCXIMGE,0,0);
MemirCopyVscr(0,1);     // copy background to vscr #1
}

void InitSlices(void)	// Function Initialises all the slice varibles
{
	Slice1.dir = 2;
	Slice1.x = 10;
	Slice1.color = 0;	// Starts from Red then Goes To Blue via Green
	Slice2.dir = 2;
	Slice2.c = 1;
	Slice3.fc = 0;	// Frame Counter starts at :0x0000|0000
        Slice4.line_off=0;      // line pixel offset!
        Slice4.line_no=53;       // Starts from Line #53 (Blank line)
			// ~0123456789ABCDEF0123456789ABCDEF012345678~	
	Slice4.line[0]="So Whaddya Think Of This Demo?";
	Slice4.line[1]="It was coded in C with a bit of ASM.";
        Slice4.line[2]="The Source Code file is:'scroll.c'";
        Slice4.line[3]="the Asm Function code is:'mfuncs.asm'";
        Slice4.line[4]="Have Fun";
        Slice4.line[5]="Now you can code for the N64!!!!";
        Slice4.line[6]="However if you have downloaded the";
        Slice4.line[7]="shareware ver. of MN64C. then you";
        Slice4.line[8]="are NOT permited to release any thing";
        Slice4.line[9]="without my permission.";
        Slice4.line[10]="However if you order for the full ver.";
        Slice4.line[11]="you'll get so much more and you'll be";
        Slice4.line[12]="allowed to do whatever you want with";
        Slice4.line[13]="your N64 creations!!!!";
        Slice4.line[14]="It's just #30.00 (Pounds Sterling)";
        Slice4.line[15]="So Whaddya think and just add #2.00";
        Slice4.line[16]="for overseas transport!!";
        Slice4.line[17]="What a DEAL!!!!!!";
        Slice4.line[18]="You'll be able to do stuff like:";
        Slice4.line[19]="PUSH,POP,CALL,PROC,MOVE... (ASM)"; 
        Slice4.line[20]="if(..), functions goto etc.(C)";
	Slice4.line[21]="My Assembler & 'C' Compiler runs";
	Slice4.line[22]="mainly on EMS!...Thats the stuff";
	Slice4.line[23]="that CRAPPY programmers can't TOUCH!";
	Slice4.line[24]="...allowing for 16384 varibles.";	
	Slice4.line[25]="...16384 functions.";
	Slice4.line[26]="...Object Code/Data <1MB";
	Slice4.line[27]="...and many more things that put the";
	Slice4.line[28]="rest of the assemblers to shame!!!!!";
        Slice4.line[29]=".";
        Slice4.line[30]=".";
        Slice4.line[31]=".";
        Slice4.line[32]="Hopefully in a few months time there";
        Slice4.line[33]="will be alot more programs for the n64";
        Slice4.line[34]="  ";
        Slice4.line[35]=" *********************************  ";
        Slice4.line[36]="**                               ** ";
        Slice4.line[37]="*                                 * ";
        Slice4.line[38]="*    /----\             /----\    * ";
        Slice4.line[39]="*      ()                 ()      * ";
        Slice4.line[40]="*    \____/             \____/    * ";
        Slice4.line[41]="*                _                * ";
        Slice4.line[42]="*               /-\               * ";
        Slice4.line[43]="*              /   \              * ";
        Slice4.line[44]="*             / \ / \             * ";
        Slice4.line[45]="*             \<> <>/             * ";
        Slice4.line[46]="*                                 * ";
        Slice4.line[47]="*            ___   ___            * ";
        Slice4.line[48]="*           /   \ /   \           * ";
        Slice4.line[49]="*                      * ";
        Slice4.line[50]="*                      * ";
        Slice4.line[51]="*           \___/ \___/           * ";
        Slice4.line[52]="*                                 * ";
        Slice4.line[53]="**                               ** ";
        Slice4.line[54]=" *********************************  ";
        Slice4.line[55]="  ";
	Slice4.line[56]="  ";
	Slice4.line[57]="  ";
	Slice4.line[58]="  ";
	Slice4.line[59]="  ";
	Slice4.line[60]="  ";
	Slice4.line[61]="  ";
	Slice4.line[62]="  ";
	Slice4.line[63]="  ";
}

///////////////////////////////////////////////////////////////////////////
// Slice #1 (The Slice for the title "Demo in MEMIR-C") ///////////////////
///////////////////////////////////////////////////////////////////////////

void DoSlice1(void)
{
	  // Make it bounce across the top of the screen!
	  if(Slice1.dir>1)	// 2 For Right
		{
	      Slice1.x=Slice1.x+1;
		}
	  if(Slice1.dir<1)	// 0 For Left
		{
		Slice1.x=Slice1.x-1;
		}	
					// & 1 for still of course!!
	  if(Slice1.x<10)
		{
		Slice1.dir=2;
		Slice1.color=Slice1.color+1;
		if(Slice1.color>2) 
			{
			Slice1.color=0;
			}
		}
	  if(Slice1.x>190)     // 310-(15*8) = 190
		{
		Slice1.dir=0;
		Slice1.color=Slice1.color+1;
		if(Slice1.color>2) 
			{
			Slice1.color=0;
			}
		}
	  			
	  if(Slice1.color<1)
			{
		      MemirStdTextColor(31,0,0);
			goto DS1a;
			}	
	  if(Slice1.color<2)
			{
			MemirStdTextColor(0,31,0);
			goto DS1a;
			}
  	  MemirStdTextColor(0,0,31);
DS1a:
        MemirStdTextShift(8,0);
        MemirStdTextBack(0);
        MemirStdText("Demo in MEMIR-C",Slice1.x,20);
}

///////////////////////////////////////////////////////////////////////////
// Slice #2 (The Slice for the E-mail Addr) ///////////////////////////////
///////////////////////////////////////////////////////////////////////////

void DoSlice2(void)
{
	  if(Slice2.dir>1)	// 2 For Right
		{
	      Slice2.c=Slice2.c+1;
		}
	  if(Slice2.dir<1)	// 0 For Left
		{
		Slice2.c=Slice2.c-1;
		}	
					// & 1 for still of course!!
	  if(Slice2.c<1)
		{
		Slice2.dir=2;
		}
	  if(Slice2.c>30)     // 310-(15*8) = 190
		{
		Slice2.dir=0;
		}

        MemirStdTextColor(Slice2.c,Slice2.c,Slice2.c);
        MemirStdTextShift(8,0);
        MemirStdTextBack(0);
        MemirStdText("colin_phillips@yahoo.com",120,192);       // Near the bot of the screen (32 pixels off it!)
}


///////////////////////////////////////////////////////////////////////////
// Slice #3 (The Slice for the frame count) ///////////////////////////////
///////////////////////////////////////////////////////////////////////////

void DoSlice3(void)
{
	  MemirStdTextColor(15,31,15);
        MemirStdTextShift(8,0);
        MemirStdTextBack(0);
        MemirStdText("Frame #:",0,200);	// Near the bot of the screen (32 pixels off it!)
	  MemirDispWord(Slice3.fc,64,200);
	  Slice3.fc=Slice3.fc+1;	// Frame Counter clocks up
}

///////////////////////////////////////////////////////////////////////////
// Slice #4 (The Slice for the info about) ////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void DoSlice4(void)
{

        Slice4.line_off=Slice4.line_off+1;
        if(Slice4.line_off>7)
                {
                Slice4.line_off=0;
                Slice4.line_no=Slice4.line_no+1;
                if(Slice4.line_no>63)
                        {
                        Slice4.line_no=0;       // loop around'o
                        }
                }


        MemirStdTextShift(8,0);
        MemirStdTextBack(0);
        y=0;  // offseted from line 0

        DS4a:
        y1 = y*8;
        y1 = 80+y1-Slice4.line_off;
        y2 = Slice4.line_no+y;
        y2 = y2&63;     // 64 lines only!
        MemirStdTextColor(15,31,15);
        MemirStdText(Slice4.line[y2],16,y1);   // Near the bot of the screen (32 pixels off it!)
        y=y+1;
        if(y<12) {
                 goto DS4a;
                 }
        // --- Now we put a border around it!!!
        x=0;
        DS4b:
        MemirDrawSprite16(35,32+x*16,72);
        x=x+1;
        if(x<16)
                {
                goto DS4b;
                }
        MemirDrawSprite16(31,16,72);
        MemirDrawSprite16(31,288,72);
        MemirDrawSprite16(37,16,88);
        MemirDrawSprite16(38,288,88);


        MemirDrawSprite16(31,0,72);
        MemirDrawSprite16(31,304,72);
        MemirDrawSprite16(31,0,88);
        MemirDrawSprite16(31,304,88);


        y=0;
        DS4c:
        MemirDrawSprite16(33,0,104+y*16);
        MemirDrawSprite16(32,304,104+y*16);
        y=y+1;
        if(y<3) {
                goto DS4c;
                }
        MemirDrawSprite16(31,0,152);
        MemirDrawSprite16(31,304,152);
        MemirDrawSprite16(39,16,152);
        MemirDrawSprite16(36,288,152);


        x=0;
        DS4d:
        MemirDrawSprite16(34,32+x*16,168);
        x=x+1;
        if(x<16)
                {
                goto DS4d;
                }
        MemirDrawSprite16(31,16,168);
        MemirDrawSprite16(31,288,168);
        MemirDrawSprite16(31,0,168);
        MemirDrawSprite16(31,304,168);

}
 //////////////////////////
